SystemOrganization addCategory: #'CardThing-Core'!
SystemOrganization addCategory: #'CardThing-Web'!

WAFileLibrary subclass: #CTResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTResources methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 22:29'!
selectorsToInclude 
	^#(styleCss )! !

!CTResources methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:28'!
styleCss
	^'
.stack {
	border: 1px solid black;
	height: 200px;
}
.selected {
	border: 2px solid red;
}
'! !

Announcement subclass: #CTStackChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

CTStackChanged subclass: #CTCardDrawnAnnouncement
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardDrawnAnnouncement class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:22'!
card: aCard
	^self basicNew
	initializeWithCard: aCard;
	yourself.! !

!CTCardDrawnAnnouncement methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:23'!
card
	^card.! !

!CTCardDrawnAnnouncement methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:22'!
initializeWithCard: aCard
	self initialize.
	card := aCard.! !

WAComponent subclass: #CTAdmin
	instanceVariableNames: 'cardList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTAdmin methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
addCard 
	| card |
	card := self call: CTCardEditor new.
	CTCard addCard: card.
	self resetCards ! !

!CTAdmin methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
initialize 
	super initialize.
	self resetCards! !

!CTAdmin methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:43'!
renderContentOn: html
	html anchor callback: [self answer]; with: 'Go Back'.
	html space. 
	html anchor callback: [self addCard]; with: 'Add Card'.
	html render: cardList! !

!CTAdmin methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:40'!
resetCards 
	cardList := CTCardList cards: CTCard cards! !

WAComponent subclass: #CTCardComponent
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardComponent class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:40'!
for: aCard
	^self basicNew 
	initializeWithCard: aCard;
	yourself ! !

!CTCardComponent methodsFor: 'actions' stamp: 'Caitlin 8/31/2012 22:34'!
editCard 
	self call: (CTCardEditor card: card)! !

!CTCardComponent methodsFor: 'initialization' stamp: 'Caitlin 8/31/2012 20:41'!
initializeWithCard: aCard
	self initialize.
	card := aCard! !

!CTCardComponent methodsFor: 'rendering' stamp: 'StuartHerring 9/1/2012 16:55'!
renderContentOn: html
	html div: [
	html anchor callback: [self editCard]; with: card name. html break.
	html strong: 'Grade: '; render: card grade. html break.
	card trigger ifNotNil: [html strong: 'Trigger: '; render: card trigger triggerName. html break.].
	card shield ifNotNil: [html strong: 'Shield: '; render: card shield. html break.].
	html strong: 'Power: '; render: card damage. html break.
	card picture ifNotNil: [html image url: ('/cards/', card picture medium)].
	
	]
	! !

WAComponent subclass: #CTCardEditor
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardEditor class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:12'!
card: aCard
	 ^self basicNew 
		initializeWithCard: aCard;
		yourself.! !

!CTCardEditor class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:14'!
new
	 ^self basicNew 
		initializeWithCard: CTCard new;
		yourself.! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:17'!
initializeWithCard: aCard
	self initialize.
	card := aCard! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 23:06'!
renderContentOn: html
	html form multipart; with: [
		html div: [html label for: #name; with: 'Name:'.
			html textInput on: #name of: card; id: #name].
		html div: [html label for: #grade; with: 'Grade:'.
			html textInput on: #grade of: card; id: #grade].
		html div: [html label for: #trigger; with: 'Trigger:'.
			html select beOptional; labels: [ :t | t triggerName ]; list: (CTTrigger triggers); on: #trigger of: card; id: #trigger].
		html div: [html label for: #shield; with: 'Shield:'.
			html textInput on: #shield of: card; id: #shield].
		html div: [html label for: #damage; with: 'Power:'.
			html textInput on: #damage of: card; id: #damage].
		html div: [html label for: #picture; with: 'Picture:'.
			html fileUpload callback: [ :p | self setPicture: p]; id: #picture].
		html div: [html submitButton callback: [self saveAndAnswer]; value: 'Save']]! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 21:24'!
saveAndAnswer 
	self answer: card! !

!CTCardEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2012 13:21'!
setPicture: aFile
	aFile ifNotNil: [ 
		card picture: (CTImage fromStream: (ReadStream on: aFile contents asByteArray))]! !

WAComponent subclass: #CTCardLibrary
	instanceVariableNames: 'cards search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:19'!
children
	^cards! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 11:21'!
initialize 
	super initialize.
	self updateCardList.
	search := ''! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 11:22'!
renderActionBarOn:  html
	html row: [
		html div span:1; with: [html anchor callback: [self answer]; with: 'Go Back'].
		html form pullRight ; class: 'form-search'; with: [
			html textInput on: #search of: self; class: 'input-medium'; class: 'search-query'.
			html submitButton class: 'btn'; value: 'Search']]! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:52'!
renderContentOn: html
	html container: [
		self renderActionBarOn: html.
		self renderLibraryOn: html.]! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:20'!
renderLibraryOn: html
	cards do: [ :c | html render: c]! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 11:21'!
search
	^search! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 11:24'!
search: aString
	search := aString.
	self updateCardList.! !

!CTCardLibrary methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 11:32'!
updateCardList 
	cards := (CTCard cards 
		select: [ :c | c name asLowercase  includesSubString: search asLowercase  ]) 
		collect: [ :c | CTCardView for: c].! !

WAComponent subclass: #CTCardList
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardList class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:33'!
cards: aCollection
	^self basicNew 
		initializeWithCards: aCollection;
		yourself ! !

!CTCardList methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:32'!
initializeWithCards: aCollection
	self initialize.
	cards := (aCollection collect: [ :c | CTCardComponent for: c])! !

!CTCardList methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 20:50'!
renderContentOn: html
	html unorderedList: [
		cards do: [ :c | html listItem: c ]]! !

WAComponent subclass: #CTCardView
	instanceVariableNames: 'card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTCardView class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:04'!
for: aCard
	^self basicNew 
	initializeWithCard: aCard;
	yourself ! !

!CTCardView methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:20'!
card
	^card! !

!CTCardView methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:27'!
currentCard 
	^card = self session currentCard ! !

!CTCardView methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:04'!
initializeWithCard: aCard
	self initialize.
	card := aCard! !

!CTCardView methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:27'!
renderContentOn: html
	card ifNil: [ ^self ].
	
	html div class: 'selected' if: self currentCard; span: 2; with: [
		html heading level: 3; with: card name.
		card picture 
			ifNotNil: [html image url: ('/cards/', card picture medium)]]! !

WAComponent subclass: #CTComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:17'!
announce: anAnnouncement
	^self session announce: anAnnouncement.! !

!CTComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:18'!
on: anAnnouncement do: aBlock
	self session announcer on: anAnnouncement do: aBlock.! !

!CTComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:16'!
phase
	^self session phase.! !

!CTComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:16'!
player
	^self session player.! !

CTComponent subclass: #CTGame
	instanceVariableNames: 'damage deck guard hand vanguard frontLeft frontRight backLeft backMiddle backRight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTGame methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 22:06'!
children 
	^{damage. deck. guard. hand. vanguard. frontLeft. frontRight. backLeft. backMiddle. backRight.}! !

!CTGame methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:38'!
initialize 
	super initialize.
	self session createGame.
	#(damage guard vanguard frontLeft frontRight backLeft backMiddle backRight)
		do: [:a | self instVarNamed: a put: (CTStackComponent for: (self player perform: a))].
	deck := CTDeckComponent for: self player deck.
	hand := CTHandComponent for: self player hand.! !

!CTGame methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:35'!
renderActionBarOn: html
	html row: [
		html div span: 1; with: [html anchor callback: [self answer]; with: 'Go Back'].
		]! !

!CTGame methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:34'!
renderContentOn: html
	html container: [
		self renderActionBarOn: html.
		self renderGameSpaceOn: html.]! !

!CTGame methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 22:35'!
renderGameSpaceOn: html
	html row: [html div span: 6; offset: 2; with: guard.].
	html row: [
		html div span: 2; with: damage.
		html div span: 8; with: [
			html row: [html div span: 2; with: frontLeft.
				html div span: 2; with: vanguard.
				html div span: 2; with: frontRight.
				html div span: 2; with: deck.].
			html row: [html div span: 2; with: backLeft.
				html div span: 2; with: backMiddle.
				html div span: 2; with: backRight.].
			html row: [html div span: 6; with: hand.].
			]]! !

CTComponent subclass: #CTStackComponent
	instanceVariableNames: 'stack cardView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

CTStackComponent subclass: #CTDeckComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTDeckComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:13'!
drawTopCard 
	self announce: (CTCardDrawnAnnouncement card: 
		(stack moveTopCardTo: self player hand)).
	self player nextPhase.
! !

!CTDeckComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:12'!
renderContentOn: html
	html div class: 'stack'; with: [
		self canDraw 
			ifTrue: [html anchor callback: [self drawTopCard ]; with: 'draw a card' ].
		html paragraph: ('{1} cards remaining' format: {stack cardCount})]! !

CTStackComponent subclass: #CTHandComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTHandComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:36'!
children 
	^cardView! !

!CTHandComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:17'!
renderContentOn: html 
	html div class: 'stack'; with: [
		cardView do: [:c | self renderCard: c on: html]
	]! !

!CTHandComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:35'!
updateCardView 
	cardView := stack collect: [:c | CTCardView for: c]! !

!CTStackComponent class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:29'!
for: aStack
	^self basicNew 
	initializeWithStack: aStack;
	yourself. ! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:44'!
acceptCard 
	self session placeCardOn: stack. ! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:40'!
canAccept
	^stack canAccept: self session currentCard  from: self session sourceStack during: self phase! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:24'!
canDraw 
	^stack canDrawDuring: self phase! !

!CTStackComponent methodsFor: 'testing' stamp: 'Caitlin 9/2/2012 16:42'!
cardSelected
	^self session cardSelected ! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:36'!
children
	^Array with: cardView! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:15'!
drawCard: aCard
	self session takeCard: aCard from: stack! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:48'!
initializeWithStack: aStack
	self initialize. 
	stack := aStack.
	self updateCardView.
	self on: CTStackChanged do: [self updateCardView ]! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:38'!
renderCard: aCardView on: html 
	self cardSelected 
		ifFalse: [self canDraw 
			ifTrue: [html anchor callback: [self drawCard: aCardView card]; with: aCardView ]
			ifFalse: [html render: aCardView]]
		ifTrue: [self canAccept
			ifTrue: [html anchor callback: [self acceptCard]; with: [html paragraph: 'place card'; render: aCardView] ]
			ifFalse: [html render: aCardView]
		]! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:18'!
renderContentOn: html 
	html div class: 'stack'; with: [self renderCard: cardView on: html]! !

!CTStackComponent methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:34'!
updateCardView 
	cardView := CTCardView for: stack topCard ! !

WAComponent subclass: #CTMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTMenu methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:41'!
admin
	self call: CTAdmin new! !

!CTMenu methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:48'!
cardLibrary 
	self call: CTCardLibrary new! !

!CTMenu methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:32'!
gameSpace 
	self call: CTGame new! !

!CTMenu methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:38'!
renderContentOn: html
	html container: [html heading level: 1; with: 'CardThing!!'.
	html unorderedList class: 'nav'; class: 'nav-list'; with: [
		self renderMenuItemsOn: html]	
	]! !

!CTMenu methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:30'!
renderMenuItemsOn: html
	html listItem class: 'nav-header'; with: 'Menu'.
	html listItem: [html anchor callback: [self admin]; with: 'Admin'.].
	html listItem: [html anchor callback: [self cardLibrary]; with: 'Card Library'].
	html listItem: [html anchor callback: [self gameSpace]; with: 'Game Space'].! !

WAComponent subclass: #CTRoot
	instanceVariableNames: 'page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTRoot class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:31'!
canBeRoot 
^true! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:26'!
children
	^Array with: page! !

!CTRoot methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 17:25'!
initialize 
	super initialize.
	page := CTMenu new! !

WASession subclass: #CTSession
	instanceVariableNames: 'player announcer currentCard sourceStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Web'!

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:15'!
announce: anAnnouncement
	announcer announce: anAnnouncement.! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:28'!
announcer 
	^announcer ! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:32'!
cardSelected
	^currentCard notNil! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:14'!
createGame
	player := CTPlayer new.! !

!CTSession methodsFor: 'accessing' stamp: 'Caitlin 9/2/2012 16:29'!
currentCard
	^currentCard! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:46'!
initialize 
	super initialize.
	announcer := Announcer new.
	self resetCurrentCard! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:58'!
phase
	^player phase! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:49'!
placeCardOn: aStack
	sourceStack moveCard: currentCard to: aStack.
	self resetCurrentCard.
	self announce: CTStackChanged new.! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:14'!
player
	^player.! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:46'!
resetCurrentCard
	currentCard := nil.
	sourceStack := nil! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:40'!
sourceStack 
	^sourceStack ! !

!CTSession methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:09'!
takeCard: aCard from: aStack
	currentCard := aCard.
	sourceStack := aStack.! !

Object subclass: #CTCard
	instanceVariableNames: 'picture name damage grade trigger effects shield'
	classVariableNames: 'AllCards'
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTCard class methodsFor: 'instance creation' stamp: 'Caitlin 8/31/2012 21:34'!
addCard: aCard
	self cards add: aCard! !

!CTCard class methodsFor: 'instance creation' stamp: 'Caitlin 8/31/2012 21:37'!
cards
	^AllCards ifNil: [AllCards := {CTCard new name: 'Card1'; yourself.
	CTCard new name: 'Card2'; yourself.
	CTCard new name: 'Card3'; yourself.} asOrderedCollection ]! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:17'!
addEffect: anEffect
	effects add: anEffect
! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:05'!
damage
	^damage! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:04'!
damage: aNumber
	damage := aNumber! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:13'!
effects
	^effects! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:07'!
grade
	^grade! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 22:26'!
grade: aNumberOrString
	| n |
	n := aNumberOrString asNumber.
	(n between: 0 and: 3) ifFalse: [self error: 'Must be between 0 and 3'].
	grade := n.! !

!CTCard methodsFor: 'initialization' stamp: 'Caitlin 8/31/2012 22:20'!
initialize 
	super initialize.
	effects := OrderedCollection new.
	grade := 0
	! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:03'!
name
	^name! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:03'!
name: aName
	name := aName! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
picture
	^picture! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:11'!
picture: aPicture
	picture := aPicture! !

!CTCard methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:09'!
printOn: aStream
	aStream nextPutAll: 'aCTCard (', name, ')'! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:15'!
removeEffect: anEffect
	effects remove: anEffect
	! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
shield
	^shield! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:10'!
shield: aNumber
	shield := aNumber! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:08'!
trigger
	^trigger! !

!CTCard methodsFor: 'accessing' stamp: 'Caitlin 8/31/2012 20:09'!
trigger: aNumber
	trigger := aNumber! !

Object subclass: #CTCardStack
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:27'!
addCard: aCard
	^cards add: aCard! !

!CTCardStack methodsFor: 'private' stamp: 'Caitlin 9/2/2012 15:55'!
basicCanDrawDuring: aPhase
	self subclassResponsibility! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:03'!
canAccept: aCard from: aStack during: aPhase
	^false! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:54'!
canDrawDuring: aPhase
	^cards notEmpty and: [self basicCanDrawDuring: aPhase ]! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:48'!
cardCount 
	^cards size ! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:34'!
collect: aBlock
	^cards collect: aBlock! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:33'!
do: aBlock
	cards do: aBlock! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 18:55'!
initialize 
	super initialize.
	cards := OrderedCollection new! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:26'!
moveCard: aCard to: aStack
	^aStack addCard: (cards remove: aCard)! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:26'!
moveTopCardTo: aStack
	^self moveCard: self topCard  to: aStack! !

!CTCardStack methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 22:22'!
topCard
	^cards ifNotEmpty: [cards last] ifEmpty: [nil]! !

CTCardStack subclass: #CTDamage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTDamage methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:55'!
basicCanDrawDuring: aPhase
	^aPhase canDrawFromDamage! !

CTCardStack subclass: #CTDeck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTDeck methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:55'!
basicCanDrawDuring: aPhase
	^aPhase canDrawFromDeck! !

CTCardStack subclass: #CTGuardCircle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTGuardCircle methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:52'!
canDrawDuring: aPhase
	^false! !

CTCardStack subclass: #CTHand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTHand methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:56'!
basicCanDrawDuring: aPhase
	^aPhase canDrawFromHand! !

CTCardStack subclass: #CTRearGuard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTRearGuard methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:56'!
basicCanDrawDuring: aPhase
	^aPhase canDrawFromRearGuard ! !

CTCardStack subclass: #CTVanguard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTVanguard methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:56'!
basicCanDrawDuring: aPhase
	^aPhase canDrawFromVanguard ! !

!CTVanguard methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 16:07'!
canAccept: aCard from: aStack during: aPhase
	^true! !

Object subclass: #CTImage
	instanceVariableNames: 'baseName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTImage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2012 13:11'!
cleanupImageDirectory
	"Searches the image directory for image files and deletes any not
	currently pointed to by a WSImage instance"
	| dir |
	dir := FileDirectory default directoryNamed: CTImage imageDir.
	dir fileNames
		do: [:f | CTImage allInstances
				detect: [:i | #(#fullsize #medium #preview #thumbnail )
						anySatisfy: [:sym | (i perform: sym) = f]]
				ifNone: [dir deleteFileNamed: f]]! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2012 13:24'!
extension
	^'.jpg'! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'srh 12/30/2008 22:42'!
fromStream: aStream
	^self basicNew
		initialize;
		generateImagesFrom: (ImageReadWriter formFromStream: aStream);
		yourself.
	! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 9/1/2012 13:14'!
imageDir
	^'images'! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/25/2009 16:30'!
mediumDimension
	^200@200.
! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
previewDimension
	^100@100.! !

!CTImage class methodsFor: 'as yet unclassified' stamp: 'srh 7/27/2009 09:52'!
thumbDimension
	^50@50.! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2012 13:24'!
extension
	^self class extension! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2012 13:25'!
fullsize
	^ baseName, '-full' , self extension! !

!CTImage methodsFor: 'private' stamp: 'StuartHerring 9/1/2012 13:11'!
generateImages
	| image |
	image := Form fromFileNamed: (self pathFor: self fullsize).
	(image scaledToSize: CTImage thumbDimension) writeJPEGfileNamed: (self pathFor: self thumbnail).
	(image scaledToSize: CTImage previewDimension) writeJPEGfileNamed: (self pathFor: self preview).
	(image scaledToSize: CTImage mediumDimension) writeJPEGfileNamed: (self pathFor: self medium).
! !

!CTImage methodsFor: 'private' stamp: 'srh 7/25/2009 16:25'!
generateImagesFrom: aForm.
	aForm writeJPEGfileNamed: (self pathFor: self fullsize).
	self generateImages! !

!CTImage methodsFor: 'initialization' stamp: 'srh 1/4/2009 11:33'!
initialize
	super initialize.
	baseName := UUID new printString! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2012 13:25'!
medium
	^ baseName, '-med' , self extension! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/24/2009 10:56'!
pathFor: aFilename
	^(FileDirectory default directoryNamed: self class imageDir) assureExistence fullName, FileDirectory slash, aFilename! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2012 13:25'!
preview
	^ baseName, '-preview' , self extension! !

!CTImage methodsFor: 'accessing' stamp: 'StuartHerring 9/1/2012 13:24'!
thumbnail
	^ baseName, '-thumb' , self extension! !

Object subclass: #CTPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

CTPhase class
	instanceVariableNames: 'instance'!

CTPhase class
	instanceVariableNames: 'instance'!

CTPhase subclass: #CTDrawPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTDrawPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:32'!
canDrawFromDeck 
	^true! !

!CTDrawPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:46'!
next
	^CTRidePhase instance.! !

!CTPhase class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:43'!
initialPhase
	^self phases first.! !

!CTPhase class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:41'!
instance 
	self = CTPhase ifTrue: [self error: 'Please use a subclass'].
	^instance ifNil: [instance := self basicNew initialize; yourself ]! !

!CTPhase class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:39'!
new
	self shouldNotImplement.! !

!CTPhase class methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:42'!
phases
	^{CTDrawPhase instance. CTRidePhase instance.}! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:31'!
canDrawFromDamage
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:30'!
canDrawFromDeck
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:31'!
canDrawFromDropZone
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:31'!
canDrawFromHand
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:30'!
canDrawFromRearGuard
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:30'!
canDrawFromVanguard
	^false.! !

!CTPhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:46'!
next
	self subclassResponsibility ! !

CTPhase subclass: #CTRidePhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTRidePhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:33'!
canDrawFromHand 
	^true! !

!CTRidePhase methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:46'!
next
	^CTDrawPhase instance.! !

Object subclass: #CTPlayer
	instanceVariableNames: 'deck hand vanguard frontRow backRow damage guard phase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:48'!
backLeft
	^backRow at: 1! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:48'!
backMiddle
	^backRow at: 2! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:48'!
backRight
	^backRow at: 3! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:44'!
damage
	^damage! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:43'!
deck
	^deck! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:47'!
frontLeft
	^frontRow at: 1! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:47'!
frontRight
	^frontRow at: 2! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:45'!
guard
	^guard! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:44'!
hand
	^hand! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 15:00'!
initialize 
	super initialize.
	deck := CTDeck new.
	hand := CTHand new.
	vanguard := CTVanguard new.
	damage := CTDamage new.
	guard := CTGuardCircle new.
	frontRow := Array with: CTRearGuard new with: CTRearGuard new.
	backRow := Array with: CTRearGuard new with: CTRearGuard new with: CTRearGuard new.
	CTCard cards shuffled do: [:c | deck addCard: c].
	phase := CTPhase initialPhase ! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:48'!
nextPhase 
	phase := phase next.! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/2/2012 14:18'!
phase
	^phase! !

!CTPlayer methodsFor: 'as yet unclassified' stamp: 'Caitlin 9/1/2012 21:44'!
vanguard
	^vanguard! !

Object subclass: #CTTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

CTTrigger subclass: #CTCriticalTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTCriticalTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Critical'! !

CTTrigger subclass: #CTDrawTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTDrawTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:45'!
triggerName
	^ 'Draw'! !

CTTrigger subclass: #CTHealTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTHealTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Heal'! !

CTTrigger subclass: #CTStandTrigger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CardThing-Core'!

!CTStandTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:46'!
triggerName
	^ 'Stand'! !

!CTTrigger class methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:48'!
triggers
	^ self subclasses! !

!CTTrigger methodsFor: 'as yet unclassified' stamp: 'Caitlin 8/31/2012 22:44'!
name
	^self class triggerName! !
